/*
 * Copyright 2007 Phidgets Inc.  All rights reserved.
 */

import com.phidgets.*;
import com.phidgets.event.*;
import java.util.*;
import java.io.*;

		
public class doorUnlocker
{
	InterfaceKitPhidget ik;
	RFIDPhidget rfid;
	int DISCOVERYMODE;
	File inFile;
	File outFile;
	Scanner reader;
	BufferedWriter writer;
	Scanner input;
	
	public void runFirst() throws Exception{
		
		DISCOVERYMODE = 1;

		inFile = new File("rfidtags.txt");
		if(!inFile.exists()){
			inFile.createNewFile();
		}
		outFile = inFile;
		writer = new BufferedWriter(new FileWriter(outFile));
			
		ik = new InterfaceKitPhidget();
		rfid = new RFIDPhidget();
		
////////////////////////////////////////////////////////////////////////////////////////////////
		//Attach, dettach and error handlers
		rfid.addAttachListener(new AttachListener() {
			public void attached(AttachEvent ae)
			{
				try
				{
					((RFIDPhidget)ae.getSource()).setAntennaOn(true);
					((RFIDPhidget)ae.getSource()).setLEDOn(true);
				}
				catch (PhidgetException ex) { }
			}
		});
		rfid.addDetachListener(new DetachListener() {
			public void detached(DetachEvent ae) {
				System.out.println("detachment of " + ae);
			}
		});
		rfid.addErrorListener(new ErrorListener() {
			public void error(ErrorEvent ee) {
				System.out.println("error event for " + ee);
			}
		});

		ik.addAttachListener(new AttachListener() {
			public void attached(AttachEvent ae) {

			}
		});
		ik.addDetachListener(new DetachListener() {
			public void detached(DetachEvent ae) {
				System.out.println("detachment of " + ae);
			}
		});
		ik.addErrorListener(new ErrorListener() {
			public void error(ErrorEvent ee) {
				System.out.println(ee);
			}
		});		
////////////////////////////////////////////////////////////////////////////////////////////////		
		//important handlers
		//interface kit
		ik.addSensorChangeListener(new SensorChangeListener() {
			public void sensorChanged(SensorChangeEvent se) {
				return;
			}
		});
		

		//RFID
		rfid.addTagGainListener(new TagGainListener()
		{
			public void tagGained(TagGainEvent oe)
			{
				String line = null;
				if(DISCOVERYMODE == 0){
					try{
						reader = new Scanner(inFile);
					}
					catch(Exception e){}
					while(reader.hasNextLine()){
						try{
							line = reader.nextLine();
							if(line.equals(oe.toString())){
								ik.setOutputState(0,true);
							}	
						}
						catch(Exception e){}	
					}
					reader.close();
				}
				if(DISCOVERYMODE == 1){
					try{
						writer.write(oe.toString());
						writer.write("\n");
					}
					catch(Exception e){}
				}
			}
		});
		
		rfid.addTagLossListener(new TagLossListener()
		{
			public void tagLost(TagLossEvent oe)
			{
				
				try{
				Thread.sleep(2000);
				ik.setOutputState(0,false);
				}
				catch(Exception e){}
			}
		});
///////////////////////////////////////////////////////////////////////////////////////////////
		//open devices
		ik.openAny();
		System.out.println("waiting for InterfaceKit attachment...");
		ik.waitForAttachment(1000);
		
		rfid.openAny();
		System.out.println("waiting for RFID attachment...");
		rfid.waitForAttachment(1000);
///////////////////////////////////////////////////////////////////////////////////////////////
		//close on input from user
		System.out.println("\nIn tag discovery mode.  Hold a tag over the reader to learn it.\nPress a key to enter active mode.\n");
		input = new Scanner(System.in);
		input.nextLine();
		DISCOVERYMODE = 0;
		writer.close();
		Thread.sleep(500);
		System.out.println("Outputting events.  Input to stop.\n");
		
		input.nextLine();
		System.out.print("closing...");
		rfid.close();
		ik.close();
		reader.close();
		System.out.println(" ok");
	}

	public static final void main(String args[]) throws Exception {
		doorUnlocker test = new doorUnlocker();
		test.runFirst();
	}
}
